* Program..: DirSelect.prg
* Author...: Jeremy Suiter
* Date.....: 07/05/2003
*
* Notice...: Copyright (c) 2003, Jeremy Suiter, All Rights Reserved
* Notes....: Visual DbEditor directory selector (from ASTAG sample)

#Include "Font.ch"
#Include "Gra.ch"
#Include "Xbp.ch"
#Include "Appevent.ch"
#Include "Common.ch"
#Include "Dmlb.ch"
#Include "Dbstruct.ch"
#Include "Directry.ch"
#Include "Inkey.ch"
#Include "DbEditor.ch"
#Include "Resources.ch"

/*
 * We use user defined events
 */
#Define  xbeDS_DirChanged           xbeP_User + 100
#Define  xbeFS_FileMarked           xbeP_User + 101
#Define  xbeFS_FileSelected         xbeP_User + 102

Static oSelector

********************
Func SelectDirectory(cDirectory)
********************
* select directory and return it
Local cPath:=cDirectory, nPos:=0
Local nEvent, mp1:=Nil, mp2:=Nil, aPos
Local oDlg, oXbp, drawingArea, oFocus:=SetAppFocus()

Begin Sequence

   If Empty(cPath)
      cPath:=AppName(.T.)
      nPos:=Rat("\", cPath)

      If nPos > 0
         cPath:=Substr(cPath,1,nPos)
      EndIf

   EndIf

   aPos:=CenterPos({247,403},AppDesktop():currentSize())

   oDlg:=XbpDialog():new(AppDesktop(), SetAppFocus(), aPos, {247,403}, , .F.)
   oDlg:icon:=ICON_MAIN
   oDlg:taskList:=.F.
   oDlg:border:=XBPDLG_RAISEDBORDERTHIN_FIXED
   oDlg:close:={|mp1,mp2,obj| PostAppEvent(xbeP_Close+1000) }
   oDlg:title:="Select Directory"
   oDlg:create()
   oDlg:setModalState(XBP_DISP_APPMODAL)
   oDlg:keyBoard:={| nKeyCode, uNIL, self | Iif(nKeyCode==xbeK_ESC,PostAppEvent(xbeP_Close+1000),Nil) }

   drawingArea:=oDlg:drawingArea
   drawingArea:setFontCompoundName("8.Helv")

   oSelector:=DirSelector():new (drawingArea, , {12,48}, {216,312})
   oSelector:tabStop:=.T.
   oSelector:startDir:=cPath
   oSelector:create()

   oXbp:=XbpPushButton():new(drawingArea, , {72,12}, {72,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } })
   oXbp:caption:="Ok"
   oXbp:tabStop:=.T.
   oXbp:create()
   oXbp:activate:={|| cPath:=oSelector:curDir(), PostAppEvent(xbeP_Close+1000) }

   oXbp:=XbpPushButton():new(drawingArea, , {156,12}, {72,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } })
   oXbp:caption:=GEN_CANCEL
   oXbp:tabStop:=.T.
   oXbp:create()
   oXbp:activate:={|| PostAppEvent(xbeP_Close+1000) }

   oDlg:show()
   SetAppFocus(oSelector)
   nEvent:=xbe_None

   Do While nEvent<>xbeP_Close+1000
      nEvent:=AppEvent(@mp1, @mp2, @oXbp)
      oXbp:handleEvent(nEvent, mp1, mp2)
      if nEvent == xbeP_Keyboard .and.;
         mp1    == xbeK_ESC
         exit
      endif      
   EndDo

   oDlg:destroy()
   SetAppFocus(oFocus)
End

Return cPath


/*
 * Class for selecting drives and directories
 */
CLASS DirSelector FROM XbpStatic
   PROTECTED:
   VAR aDrives
   VAR oItem


   EXPORTED:
   VAR startDir
   VAR dirTree
   VAR driveList
   VAR directory

   METHOD init, create, fillTree, curDir
ENDCLASS

/*
 * Initialize the object
 */
METHOD DirSelector:init(oParent, oOwner, aPos, aSize, aPresParam, lVisible)

   ::xbpStatic:init(oParent, oOwner, aPos, aSize, aPresParam, lVisible)
   ::xbpStatic:type   :=XBPSTATIC_TYPE_RAISEDRECT

   ::dirTree           :=XbpTreeView():new(self)
   ::dirTree:tabStop   :=.T.
   ::dirTree:hasLines  :=.T.
   ::dirTree:hasButtons:= .T.

   ::driveList        :=XbpComboBox():new(self)
   ::driveList:tabStop:=.T.
   ::driveList:type   :=XBPCOMBO_DROPDOWNLIST

   ::startDir         :=CurDrive() + ":\" + CurDir()
RETURN self

/*
 * Request system resources and fill tree view with
 * data from current directory
 */
METHOD DirSelector:create(oParent, oOwner, aPos, aSize, aPresParam, lVisible)

   LOCAL nDrive

   ::xbpStatic:create(oParent, oOwner, aPos, aSize, aPresParam, lVisible)

   aSize:=::currentSize()

  /*
   * The tree view creates a user-defined event with the selected
   * directory attached as the first message parameter
   */
   ::dirTree:create  (,, {4, 30}, {aSize[1]-8, aSize[2]-30-4 })
   ::dirTree:itemSelected:={|oItem| ::fillTree(oItem) }
   ::dirTree:itemMarked  :={|oItem| ::directory:=oItem:getData(), PostAppEvent(xbeDS_DirChanged, oItem:getData()) }

   IF At(";", ::startDir) <> 0
      ::startDir:=Left(::startDir, At(";", ::startDir) -1)
   ENDIF

   ::dirTree:rootItem:setData(::startDir)
   ::driveList:create(,, {4, 30-4-24-96}, {aSize[1]-8, 24+96 })

   ::aDrives:=AvailDrives()
   AEval(::aDrives, {|c| ::driveList:xbpListBox:addItem(c+":") })

   IF At(":", ::startDir) == 2
      nDrive:=AScan(::aDrives, Left(::startDir,1))
   ELSE
      nDrive:=AScan(::aDrives, CurDrive())
   ENDIF

   IF nDrive == 0
      Errm(ERR_ERRM24)
      ::startDir:=CurDrive() + ":\" + CurDir()
      ::dirTree:rootItem:setData(::startDir)
      nDrive    :=AScan(::aDrives, CurDrive())
   ENDIF

   ::driveList:xbpListBox:setData({ nDrive })
   ::driveList:xbpListBox:itemSelected:={|| ::fillTree() }

   ::fillTree(::dirTree:rootItem)
RETURN self

/*
 * Rebuild the tree view with data from the selected directory. Each
 * XbpTreeViewItem contains a character string of the directory
 * which is displayed by the item
 */
METHOD DirSelector:fillTree(oItem)
   LOCAL aItems   :=::dirTree:rootItem:getChildItems()
   LOCAL cDrive   :=AllTrim(::driveList:xbpSLE:getData())
   LOCAL cDir, aDir, i, imax, nLen, oParent, oTemp, cTemp, oNewParent

   IF oItem <> NIL .AND. ::isVisible() .AND. Len(Directory(oItem:getData() + "\*.", "D")) == 2
      Tone(1000)
      RETURN self
   ENDIF

   ::dirTree:LockUpdate(.T.)

   AEval(aItems, {|obj| ::dirTree:rootItem:delItem(obj) })
   cDir   :=cDrive

  /*
   * The tree view begins with the drive letter
   */
   oParent:=::dirTree:rootItem:addItem(cDrive, ICON_DRIVE, ICON_DRIVE, ICON_DRIVE,, cDrive)

   IF oItem == NIL
      oItem:=oParent
   ENDIF

   ::oItem:=oItem

  /*
   * An XbpTreeviewItem is created for each sub-directory
   */
   DO WHILE Upper(cDir) <> Upper(oItem:getData())
      cTemp:=SubStr(oItem:getData(), Len(cDir)+2)
      nLen:=At("\", cTemp) - 1
      IF nLen < 0
          nLen:=len(cTemp)
      ENDIF
      cTemp:=SubStr(cTemp, 1, nLen)

      aDir:=Directory(cDir + "\", "D")
      imax:=Len(aDir)
      FOR i:=1 TO imax
         IF "D" $ aDir[i,F_ATTR]        .AND. ;
            .NOT. aDir[i,F_NAME] == "." .AND. ;
            .NOT. aDir[i,F_NAME] == ".."
            oTemp:=oParent:addItem(aDir[i,F_NAME]   , ;
                                      ICON_CLOSEDFOLDER, ;
                                      ICON_CLOSEDFOLDER, ;
                                      ICON_OPENFOLDER  , ;
                                      NIL              , ;
                                      cDir + "\" + aDir[i,F_NAME])
            IF Upper(cDir + "\" + aDir[i,F_NAME]) == Upper(SubStr(oItem:getData(), 1, Len(cDir + "\" + cTemp)))
               oNewParent:=oTemp
            ENDIF
         ENDIF
      NEXT
      cDir += "\" + cTemp
      oParent:expand(.T.)
      IF oNewParent <> NIL
         oParent:=oNewParent
      ENDIF
   ENDDO


  /*
   * Create XbpTreeViewItems for the files in the lowest subdirectory
   */
   aDir:=Directory(cDir + "\", "D")

   imax:=Len(aDir)
   FOR i:=1 TO imax
      IF "D" $ aDir[i,F_ATTR]        .AND. ;
         .NOT. aDir[i,F_NAME] == "." .AND. ;
         .NOT. aDir[i,F_NAME] == ".."

         oParent:addItem(aDir[i,F_NAME]   , ;
                          ICON_CLOSEDFOLDER, ;
                          ICON_CLOSEDFOLDER, ;
                          ICON_OPENFOLDER  , ;
                          NIL              , ;
                          cDir + "\" + aDir[i,F_NAME])
      ENDIF
   NEXT

   oParent:expand(.T.)
   ::dirTree:SetData(oParent)

   ::dirTree:LockUpdate(.F.)
   ::dirTree:InvalidateRect()

   PostAppEvent(xbeDS_DirChanged, oParent:getData())
RETURN self

/*
 * Return the currently selected directory
 */
METHOD DirSelector:curDir
//RETURN ::oItem:getData()
Return ::directory+"\"

/*
 * This function returns an array filled with letters of all available drives
 * except floppy drives
 */
#define DRIVE_NOT_READY  21

FUNCTION AvailDrives()
   Local i
   LOCAL cDrive:=CurDrive()
   LOCAL aDrives:= { cDrive }
   LOCAL bError:=ErrorBlock({|oErr| DriveError(oErr, aDrives) })

   FOR i:=3 TO 26
      BEGIN SEQUENCE
        Curdrive(Chr(64+i))
        CurDir()
        IF AScan(aDrives, CurDrive()) == 0
           AAdd(aDrives, Curdrive())
        ENDIF
      ENDSEQUENCE
   NEXT

   CurDrive(cDrive)

   ErrorBlock(bError)
RETURN ASort(aDrives)

/*
 * Handle runtime error when a drive is not ready
 */
STATIC PROCEDURE DriveError(oError, aDrives)
   IF oError:osCode == DRIVE_NOT_READY
      AAdd(aDrives, oError:args[1])
   ENDIF
   BREAK
RETURN
