* Program..: Index.prg
* Author...: Jeremy Suiter
* Date.....: 26/03/2003
*
* Notice...: Copyright (c) 2003, Jeremy Suiter, All Rights Reserved
* Notes....: Visual DbEditor index functions

#Include "Font.ch"
#Include "Gra.ch"
#Include "Xbp.ch"
#Include "Appevent.ch"
#Include "Common.ch"
#Include "Dmlb.ch"
#Include "Dbstruct.ch"
#Include "Inkey.ch"
#Include "DbEditor.ch"
#Include "Resources.ch"

Static oFileList, oOrdList, oTagInfo, oPBIndex, oPBClose, oPBReIndex, oPBSelect, oFieldList, oIndexkey, oUnique, oDescend, oTagName, ;
   oPBCreate, oForCond, oReindex, oCreate

*************
Func SetIndex()
*************
Local nEvent:=Nil, mp1:=Nil, mp2:=Nil, aPos:={}, x:=Nil , aFiles:={}
Local oDlg, oXbp, drawingArea, oGroup1, oGroup2

Begin Sequence

   If oFocusBrowse==Nil .Or. (!"NTX"$DbInfo(DBO_DBENAME) .And. !"CDX"$DbInfo(DBO_DBENAME))
      Break
   EndIf

   aPos:=CenterPos({474,453},AppDesktop():currentSize())

   oDlg:=XbpDialog():new(AppDesktop(), SetAppWindow(), aPos, {474,453}, , .F.)
   oDlg:icon:=ICON_MAIN
   oDlg:taskList:=.F.
   oDlg:border:=XBPDLG_RAISEDBORDERTHIN_FIXED
   oDlg:title:="Table Index Options"
   oDlg:close:={|mp1,mp2,obj| PostAppEvent(xbeP_Close+1000) }
   oDlg:create()
   oDlg:setModalState(XBP_DISP_APPMODAL)
   oDlg:keyBoard:={| nKeyCode, uNIL, self | Iif(nKeyCode==xbeK_ESC,PostAppEvent(xbeP_Close+1000),Nil) }

   drawingArea:=oDlg:drawingArea
   drawingArea:setFontCompoundName("8.Helv")

   // set index file
   oGroup1:=XbpStatic():new(drawingArea, , {12,328}, {444,96})
   oGroup1:caption:="Select Index File"
   oGroup1:clipSiblings:=.T.
   oGroup1:type:=XBPSTATIC_TYPE_GROUPBOX
   oGroup1:create()

   oXbp:=XbpStatic():new(oGroup1, , {12,48}, {108,24})
   oXbp:caption:="Index File"
   oXbp:clipSiblings:=.T.
   oXbp:options:=XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_RIGHT
   oXbp:create()

   oFileList:=XbpCombobox():new(oGroup1, , {132,12}, {300,60}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD }, { XBP_PP_DISABLED_BGCLR, GRA_CLR_WHITE }})
   oFileList:tabstop:=.T.
   oFileList:type:=XBPCOMBO_DROPDOWN
   oFileList:XbpSLE:editable:=.F.
   oFileList:setInputFocus:={| uNil1,uNil2,self | XbpBorder(self,GRA_CLR_BLUE) }
   oFileList:killInputFocus:={| uNil1,uNil2,self | XbpBorder(self, GRA_CLR_BACKGROUND) }
   oFileList:create()

   If !".CDX"$OrdBagName(OrdNumber())
      oFileList:XbpSLE:setData(Upper(OrdBagName(OrdNumber())))
   EndIf

   If "NTX"$DbInfo(DBO_DBENAME) .Or. "CDX"$DbInfo(DBO_DBENAME)
      aFiles:=Directory(cPath+"*"+OrdBagExt())
   EndIf

   For x:=1 To Len(aFiles)
      oFileList:addItem(Upper(aFiles[x,1]))
   Next

   aFiles:={}
   IIf("CDX"$Upper(DbInfo(DBO_DBENAME)),oFileList:disable(),oFileList:enable())

   oPBIndex:=XbpPushButton():new(oGroup1, , {12,12}, {96,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } })
   oPBIndex:caption:="Open Index File"
   oPBIndex:tabStop:=.T.
   oPBIndex:create()
   oPBIndex:activate:={|| OpenIndexFile(), ShowIndexInfo(OrdNumber()) }
   IIf("CDX"$Upper(DbInfo(DBO_DBENAME)),oPBIndex:disable(),oPBIndex:enable())

   // select index to use for current order
   oGroup2:=XbpStatic():new(drawingArea, , {12,48}, {444,276})
   oGroup2:caption:="Select Index"
   oGroup2:clipSiblings:=.T.
   oGroup2:type:=XBPSTATIC_TYPE_GROUPBOX
   oGroup2:create()

   // list of index tags
   oOrdList:=XbpListBox():new(oGroup2, , {12,42}, {120,210}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } })
   oOrdList:tabStop:=.T.
   oOrdList:markMode:=XBPLISTBOX_MM_SINGLE
   oOrdList:itemMarked:={|uNIL1, uNIL2, self| ShowIndexInfo(oOrdList:getData()[1]-1) }
   oOrdList:itemSelected:={|| SelectOrder() }
   oOrdList:setInputFocus:={| uNil1,uNil2,self | XbpBorder(self,GRA_CLR_BLUE) }
   oOrdList:killInputFocus:={| uNil1,uNil2,self | XbpBorder(self, GRA_CLR_BACKGROUND) }
   oOrdList:create()
   oOrdList:addItem("<Natural Order>")

   For x:=1 To Len(OrdList())
     oOrdList:addItem(Iif(Empty(OrdName(x)),Ntrim(x),OrdName(x)))
   Next

   oOrdList:setData({OrdNumber()+1},.T.)

   // list of tag information
   oTagInfo:=XbpListBox():new(oGroup2, , {140,42}, {294,210}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } })
   oTagInfo:tabStop:=.T.
   oTagInfo:markMode:=XBPLISTBOX_MM_SINGLE
   oTagInfo:horizScroll:=.T.
   oTagInfo:create()
   ShowIndexInfo(OrdNumber())

   // recessed static for index progress bar
   oXbp:=XbpStatic():new(oGroup2, , {12,12}, {424,20})
   oXbp:type:=XBPSTATIC_TYPE_RECESSEDBOX
   oXbp:create()

   oReindex:=ProgressBar():new(oGroup2, , {12,12}, {424,20},,.F.)
   oReindex:create()
   oReindex:hide()

   // pushbuttons
   oXbp:=XbpPushButton():new(drawingArea, , {78,12}, {66,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } })
   oXbp:caption:="New"
   oXbp:tabStop:=.T.
   oXbp:create()
   oXbp:activate:={|| CreateIndex() }

   oPBClose:=XbpPushButton():new(drawingArea, , {156,12}, {66,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } })
   oPBClose:caption:=IIf("CDX"$Upper(DbInfo(DBO_DBENAME)),"Destroy",GEN_CLOSE)
   oPBClose:tabStop:=.T.
   oPBClose:create()

   If "CDX"$Upper(DbInfo(DBO_DBENAME))
      oPBClose:activate:={|| DestroyTag(), ShowIndexInfo(OrdNumber()) }
   Else
      oPBClose:activate:={|| CloseIndexFile(), ShowIndexInfo(OrdNumber()) }
   EndIf

   IIf(OrdCount()=0,oPBClose:disable(),oPBClose:enable())

   oPBReIndex:=XbpPushButton():new(drawingArea, , {234,12}, {66,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } })
   oPBReIndex:caption:="Reindex"
   oPBReIndex:tabStop:=.T.
   oPBReIndex:create()
   oPBReIndex:activate:={|| ReIndex() }

   oPBSelect:=XbpPushButton():new(drawingArea, , {312,12}, {66,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } })
   oPBSelect:caption:="Select"
   oPBSelect:tabStop:=.T.
   oPBSelect:create()
   oPBSelect:activate:={|| SelectOrder() }
   IIf(OrdCount()=0,oPBSelect:disable(),Nil)

   oXbp:=XbpPushButton():new(drawingArea, , {390,12}, {66,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } })
   oXbp:caption:="Exit"
   oXbp:tabStop:=.T.
   oXbp:create()
   oXbp:activate:={|| PostAppEvent(xbeP_Close+1000) }

   oDlg:show()
   SetAppFocus(oFileList)
   nEvent:=xbe_None

   Do While nEvent<>xbeP_Close+1000
      nEvent:=AppEvent(@mp1, @mp2, @oXbp)
      oXbp:handleEvent(nEvent, mp1, mp2)
      if nEvent == xbeP_Keyboard .and.;
         mp1    == xbeK_ESC
         exit
      endif      
   EndDo

   oDlg:Destroy()
   SetAppFocus(oFocusBrowse)
End

Return Nil

****************
Func SelectOrder()
****************
* select order hilighted

Begin Sequence
   OrdSetFocus(oOrdList:getData()[1]-1)
   oOrdList:setData({OrdNumber()+1},.T.)
   ShowIndexInfo(OrdNumber())
   oFocusBrowse:refreshAll()
   oFocusBrowse:forceStable()
End

Return Nil

******************
Func ShowIndexInfo(nOrder)
******************
* show tag info for selected index
Local nOldOrder:=0

Begin Sequence
   oTagInfo:Clear()

   If nOrder>0
      oTagInfo:addItem("INDEX FILE: "+Upper(OrdBagName(nOrder)))
      oTagInfo:addItem("")
      oTagInfo:addItem("KEY: "+OrdKey(nOrder))
      oTagInfo:addItem("FOR: "+OrdFor(nOrder))
      nOldOrder:=OrdNumber()
      OrdSetFocus(nOrder)
      oTagInfo:addItem("UNIQUE: "+IIf(OrdIsUnique(),"YES","NO"))
      oTagInfo:addItem("DESCENDING: "+IIf(OrdIsDescend(),"YES","NO"))
      OrdSetFocus(nOldOrder)
   EndIf

End

Return oTagInfo

************
Func ReIndex()
************
* re-create all indexes for current open table
* aIndexes structure is {index filename, tag, key, unique, descending, for condition}
Local aIndexes:={}, nOrder:=0, x, lShared:=DbInfo(DBO_SHARED), bBlock, bTemp, cFileDbe:=DbInfo(DBO_DBENAME)

Begin Sequence

   If OrdCount()=0
      Errm(ERR_ERRM30)
      Break
   EndIf

   // remember original order number
   nOrder:=OrdNumber()

   // build list of index elements
   For x:=1 To OrdCount()
      OrdSetFocus(x)
      aAdd(aIndexes,{Upper(cPath+OrdBagName(x)), OrdName(x), OrdKey(x), OrdIsUnique(), OrdIsDescend(), OrdFor(x)})
   Next

   If !YesNo("Recreate "+Iif(OrdCount()>1,"ALL indexes","index")+" for this table","Indexes")
      Break
   EndIf

   // open exclusively
   If lShared
      DbCloseArea()

      If !NetUse(cFile,.T.,,,cFileDbe)
         Errm(ERR_ERRM31)

         If !NetUse(cFile,,,,cFileDbe)
            Errm(ERR_ERRM32)
            Break
         EndIf

      EndIf

   EndIf

   // close all index files
   OrdListClear()

   // recreate all indexes
   If ".CDX"$aIndexes[1,1]
      FErase(aIndexes[1,1])
   EndIf

   For x:=1 To Len(aIndexes)

      If !".CDX"$aIndexes[x,1]
         FErase(aIndexes[x,1])
      EndIf

      oOrdList:setData({x+1},.T.)
      oReindex:minimum:=1
      oReindex:maximum:=LastRec()
      oReindex:current:=1
      oReindex:show()
      bTemp:=&("{|| "+aIndexes[x,3]+" }")
      bBlock:={|| oReindex:increment(), Eval(bTemp) }
      OrdCondSet(aIndexes[x,6], , , , , , , , , ,aIndexes[x,5])
      OrdCreate(aIndexes[x,1], aIndexes[x,2], aIndexes[x,3], bBlock, aIndexes[x,4])
      oReindex:hide()
   Next

   // reset file status back to shared If necessary
   If lShared
      OrdListClear()
      DbCloseArea()

      If !NetUse(cFile,,,Iif(".CDX"$aIndexes[1,1],.F.,.T.),cFileDbe)
         Errm(ERR_ERRM32)
         Break
      EndIf

      If !".CDX"$aIndexes[1,1]

         For x:=1 To Len(aIndexes)
            OrdListAdd(aIndexes[x,1])
         Next

      EndIf

   EndIf

   // reset original order
   OrdSetFocus(nOrder)
   oOrdList:setData({nOrder+1},.T.)
   DbGoTop()
   DbRegisterClient(oFocusBrowse:setParent():setParent())
   oFocusBrowse:refreshAll()
   oFocusBrowse:forceStable()
   Errm(ERR_ERRM33,ERR_ERRM34)
End

Return Nil

******************
Func OpenIndexFile()
******************
* open index file
Local x, lOpen:=.F., cFile:=""

Begin Sequence
   cFile:=oFileList:XbpSle:getData()

   If Empty(cFile)
      Break
   EndIf

   For x:=1 To OrdCount()

      If Upper(OrdBagName(x))==Upper(cFile)
         lOpen:=.T.
         Exit
      EndIf

   Next

   If !lOpen
      OrdListAdd(cPath+cFile)
      OrdSetFocus(OrdCount())
      oOrdList:addItem(IIf(Empty(OrdName(OrdNumber())),Ntrim(OrdNumber()),OrdName(OrdNumber())))
      oOrdList:setData({OrdNumber()+1},.T.)

      If OrdCount()>0
         oPBClose:enable()
         oPBSelect:enable()
         oPBReIndex:enable()
      EndIf

   EndIf

End

Return Nil

*******************
Func CloseIndexFile()
*******************
* closes all open indexes

Begin Sequence
   OrdListClear()
   oOrdList:Clear()
   oOrdList:addItem("<Natural Order>")

   If OrdCount()=0
      oPBClose:disable()
      oPBReIndex:disable()
      oPBSelect:disable()
   EndIf

End

Return Nil

***************
Func DestroyTag()
***************
* closes all open indexes
Local lShared:=DbInfo(DBO_SHARED), nOrdDelete:=oOrdList:getData()[1]-1, cFileDbe:=DbInfo(DBO_DBENAME)

Begin Sequence

   If nOrdDelete==0
      Break
   EndIf

   If lShared
      DbCloseArea()

      If !NetUse(cFile,.T.,,,cFileDbe)
         Errm(ERR_ERRM31)

         If !NetUse(cFile,,,,cFileDbe)
            Errm(ERR_ERRM32)
            Break
         EndIf

      EndIf

   EndIf

   If YesNo("Are you sure you want to destroy tag "+Upper(OrdName(nOrdDelete)))
      // set to zero order
      OrdSetFocus(0)
      // destroy tag
      OrdDestroy(OrdName(nOrdDelete))
      oOrdList:delItem(nOrdDelete+1)

      If OrdCount()=0
         oPBClose:disable()
         oPBReIndex:disable()
         oPBSelect:disable()
      EndIf

   EndIf

   // reset file status back to shared If necessary
   If lShared
      OrdListClear()
      DbCloseArea()

      If !NetUse(cFile,,,,cFileDbe)
         Errm(ERR_ERRM32)
         Break
      EndIf

   EndIf

   OrdSetFocus(1)
   oOrdList:setData({2},.T.)
End

Return Nil

****************
Func CreateIndex()
****************
* create new tag or index
Local nEvent:=Nil, mp1:=Nil, mp2:=Nil, aPos:={}, oFocus:=SetAppFocus()
Local oDlg, oXbp, drawingArea, oGroup1, oGroup2, oGroup3, oGroup4

Begin Sequence
   aPos:=CenterPos({584,429},AppDesktop():currentSize())

   oDlg:=XbpDialog():new(AppDesktop(), SetAppFocus(), aPos, {584,429}, , .F.)
   oDlg:icon:=ICON_MAIN
   oDlg:taskList:=.F.
   oDlg:border:=XBPDLG_RAISEDBORDERTHIN_FIXED
   oDlg:title:="Create Index"
   oDlg:close:={|mp1,mp2,obj| PostAppEvent(xbeP_Close+1000) }
   oDlg:create()
   oDlg:setModalState(XBP_DISP_APPMODAL)
   oDlg:keyBoard:={| nKeyCode, uNIL, self | Iif(nKeyCode==xbeK_ESC,PostAppEvent(xbeP_Close+1000),Nil) }

   drawingArea:=oDlg:drawingArea
   drawingArea:setFontCompoundName("8.Helv")

   // display fields that can be indexed from
   oGroup1:=XbpStatic():new(drawingArea, , {12,48}, {204,348})
   oGroup1:caption:="Fields"
   oGroup1:clipSiblings:=.T.
   oGroup1:type:=XBPSTATIC_TYPE_GROUPBOX
   oGroup1:create()

   oFieldList:=XbpListBox():new(oGroup1, , {12,12}, {180,312}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } })
   oFieldList:tabStop:=.T.
   oFieldList:markMode:=XBPLISTBOX_MM_SINGLE
   oFieldlist:itemSelected:={|uNIL1, uNIL2, self| AddFieldToKey() }
   oFieldList:setInputFocus:={| uNil1,uNil2,self | XbpBorder(self,GRA_CLR_BLUE) }
   oFieldList:killInputFocus:={| uNil1,uNil2,self | XbpBorder(self, GRA_CLR_BACKGROUND) }
   oFieldList:create()
   AddFields(oFieldList)
   oFieldList:setData({1},.T.)

   // display and allow edit of index key
   oGroup2:=XbpStatic():new(drawingArea, , {228,232}, {336,164})
   oGroup2:caption:="Index Key"
   oGroup2:clipSiblings:=.T.
   oGroup2:type:=XBPSTATIC_TYPE_GROUPBOX
   oGroup2:create()

   oIndexKey:=XbpMle():new(oGroup2, , {12,12}, {312,128}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } })
   oIndexKey:tabStop:=.T.
   oIndexKey:horizScroll:=.F.
   oIndexKey:setInputFocus:={| uNil1,uNil2,self | XbpBorder(self,GRA_CLR_BLUE) }
   oIndexKey:killInputFocus:={| uNil1,uNil2,self | XbpBorder(self, GRA_CLR_BACKGROUND) }
   oIndexKey:create()

   // set index options
   oGroup3:=XbpStatic():new(drawingArea, , {228,88}, {336,132})
   oGroup3:caption:="Index Options"
   oGroup3:clipSiblings:=.T.
   oGroup3:type:=XBPSTATIC_TYPE_GROUPBOX
   oGroup3:create()

   oXbp:=XbpStatic():new(oGroup3, , {12,84}, {24,24})
   oXbp:caption:=GEN_FOR
   oXbp:clipSiblings:=.T.
   oXbp:options:=XBPSTATIC_TEXT_VCENTER
   oXbp:create()

   oForCond:=XbpSLE():new(oGroup3, , {36,84}, {288,24}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } })
   oForCond:tabStop:=.T.
   oForCond:setInputFocus:={| uNil1,uNil2,self | XbpBorder(self,GRA_CLR_BLUE) }
   oForCond:killInputFocus:={| uNil1,uNil2,self | XbpBorder(self, GRA_CLR_BACKGROUND) }
   oForCond:create()

   oDescend:=XbpCheckbox():new(oGroup3, , {120,48}, {96,24})
   oDescend:caption:="Descending"
   oDescend:tabStop:=.T.
   oDescend:setInputFocus:={| uNil1,uNil2,self | XbpBorder(self,GRA_CLR_BLUE) }
   oDescend:killInputFocus:={| uNil1,uNil2,self | XbpBorder(self, GRA_CLR_BACKGROUND) }
   oDescend:create()

   oUnique:=XbpCheckbox():new(oGroup3, , {36,48}, {72,24})
   oUnique:caption:="Unique"
   oUnique:tabStop:=.T.
   oUnique:setInputFocus:={| uNil1,uNil2,self | XbpBorder(self,GRA_CLR_BLUE) }
   oUnique:killInputFocus:={| uNil1,uNil2,self | XbpBorder(self, GRA_CLR_BACKGROUND) }
   oUnique:create()

   oXbp:=XbpStatic():new(oGroup3, , {12,12}, {24,24})
   oXbp:caption:="Tag"
   oXbp:clipSiblings:=.T.
   oXbp:options:=XBPSTATIC_TEXT_VCENTER
   oXbp:create()

   oTagName:=XbpSLE():new(oGroup3, , {36,12}, {288,24}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } })
   oTagName:tabStop:=.T.
   oTagName:setInputFocus:={| uNil1,uNil2,self | XbpBorder(self,GRA_CLR_BLUE) }
   oTagName:killInputFocus:={| uNil1,uNil2,self | XbpBorder(self, GRA_CLR_BACKGROUND) }
   oTagName:create()

   If !"CDX"$DbInfo(DBO_DBENAME)
      oTagName:disable()
   EndIf

   // show progress bar
   oGroup4:=XbpStatic():new(drawingArea, , {228,48}, {336,40})
   oGroup4:clipSiblings:=.T.
   oGroup4:type:=XBPSTATIC_TYPE_GROUPBOX
   oGroup4:create()

   oXbp:=XbpStatic():new(oGroup4, , {4,6}, {326,20})
   oXbp:type:=XBPSTATIC_TYPE_RECESSEDBOX
   oXbp:create()

   oCreate:=ProgressBar():new(oGroup4, , {4,6}, {326,20},,.F.)
   oCreate:create()
   oCreate:hide()

   // pushbuttons
   oPBCreate:=XbpPushButton():new(drawingArea, , {360,12}, {96,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } })
   oPBCreate:caption:="Create"
   oPBCreate:tabStop:=.T.
   oPBCreate:create()
   oPBCreate:activate:={|| IIf(IndexCreate(), PostAppEvent(xbeP_Close+1000), Nil) }

   oXbp:=XbpPushButton():new(drawingArea, , {468,12}, {96,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } })
   oXbp:caption:=GEN_CANCEL
   oXbp:tabStop:=.T.
   oXbp:create()
   oXbp:activate:={|| PostAppEvent(xbeP_Close+1000) }

   oDlg:show()
   SetAppFocus(oFieldList)
   nEvent:=xbe_None

   Do While nEvent<>xbeP_Close+1000
      nEvent:=AppEvent(@mp1, @mp2, @oXbp)
      oXbp:handleEvent(nEvent, mp1, mp2)
      if nEvent == xbeP_Keyboard .and.;
         mp1    == xbeK_ESC
         exit
      endif
      If (!Empty(oIndexKey:getData()) .And. "CDX"$DbInfo(DBO_DBENAME) .And. !Empty(oTagName:getData())) .Or. ;
            (!Empty(oIndexKey:getData()) .And. "NTX"$DbInfo(DBO_DBENAME) .And. Empty(oTagName:getData()))
         oPBCreate:enable()
      Else
         oPBCreate:disable()
      EndIf

   EndDo

   oDlg:Destroy()
   SetAppFocus(oFocus)
End

Return Nil

*************************
Static Func AddFieldToKey()
*************************
* add field to key
Local cTemp:=""

Begin Sequence
   cTemp:=oFieldList:getItem(oFieldList:getData()[1])
   cTemp:=Left(cTemp,At("[",cTemp)-2)

   If !cTemp$oIndexKey:getData()
      oIndexKey:setData(oIndexKey:getData()+Iif(Empty(oIndexKey:getData()),"","+")+cTemp)
   EndIf

End

Return Nil

****************
Func IndexCreate()
****************
* create new index
Local cNewFile:=Upper(Left(cFile,Len(cFile)-4)+OrdBagExt()), oDlg:=Nil, oFocus:=SetAppFocus(), bBlock:=Nil, bTemp:=Nil, lRetVal:=.T.

Begin Sequence

   IF EMPTY(cNewFile)  // No Index open/existing
      cFile := DbInfo(DBO_FILENAME)  // Filename including path
   ELSE
      cFile := cPath + cNewFile
   ENDIF

   cNewFile := RemoveFileExt(cNewFile)

   If "NTX"$DbInfo(DBO_DBENAME)
      oDlg:=XbpFileDialog():new()
      oDlg:fileFilters:={ {"NTX Index","NTX"} }
      oDlg:center:=.T.
      oDlg:create()

      Do While .T.
         cNewFile:=oDlg:saveAs(cDirectory+"*.NTX")

         If File(cNewFile) .And. !YesNo("File already exists, overwrite","Overwrite")
            Loop
         Else
            Exit
         EndIf

      EndDo

      oDlg:destroy()
      SetAppFocus(oFocus)
   EndIf

   If !TestCondition(oIndexKey:getData()) .Or. (!Empty(oForCond:getData()) .And. !TestCondition(oForCond:getData()))
      lRetVal:=.F.
      Break
   EndIf

   oCreate:minimum:=1
   oCreate:maximum:=LastRec()
   oCreate:current:=1
   oCreate:show()
   bTemp:=&("{|| "+oIndexKey:getData()+" }")
   bBlock:={|| oCreate:increment(), Eval(bTemp) }
   OrdCondSet(oForCond:getData(), , , , , , , , , ,oDescend:getData())
   OrdCreate(cNewFile, oTagName:getData(), oIndexKey:getData(), bBlock, oUnique:getData())
   oCreate:hide()
   oOrdList:addItem(IIf(Empty(OrdName(OrdNumber())),Ntrim(OrdNumber()),OrdName(OrdNumber())))
   oOrdList:setData({OrdNumber()+1},.T.)

   If OrdCount()>0
      oPBClose:enable()
      oPBSelect:enable()
      oPBReIndex:enable()
   EndIf

End

Return lRetVal
