* Program..: Options.prg
* Author...: Jeremy Suiter
* Date.....: 26/03/2003
*
* Notice...: Copyright (c) 2003, Jeremy Suiter, All Rights Reserved
* Notes....: Visual DbEditor options functions

#Include "Font.ch"
#Include "Gra.ch"
#Include "Xbp.ch"
#Include "Appevent.ch"
#Include "Common.ch"
#Include "Dmlb.ch"
#Include "Dbstruct.ch"
#Include "Inkey.ch"
#Include "DbEditor.ch"
#Include "Resources.ch"

Static oFileExt:=Nil, oExtDesc:=Nil, oDbe:=Nil, oDefDir:=Nil

***************
Func SetOptions()
***************
* set default options
Local nEvent:=Nil, mp1:=Nil, mp2:=Nil, aPos:={}, oFocus:=SetAppFocus(), lSet:=.F., aDbe:={}, oController:=Nil
Local oDlg, oXbp, drawingArea, oGroup1:=Nil, oGroup2:=Nil, oGroup3:=Nil, x:=Nil, aIniFile:={}

Begin Sequence
   aPos:=CenterPos({473,284},AppDesktop():currentSize())

   oDlg:=XbpDialog():new(AppDesktop(), SetAppWindow(), aPos, {473,284}, , .F.)
   oDlg:icon:=ICON_MAIN
   oDlg:taskList:=.F.
   oDlg:border:=XBPDLG_RAISEDBORDERTHIN_FIXED
   oDlg:title:="Set Default Options"
   oDlg:close:={|mp1,mp2,obj| PostAppEvent(xbeP_Close+1000) }
   oDlg:create()
   oDlg:setModalState(XBP_DISP_APPMODAL)
   oDlg:keyBoard:={| nKeyCode, uNIL, self | Iif(nKeyCode==xbeK_ESC,PostAppEvent(xbeP_Close+1000),Nil) }

   drawingArea:=oDlg:drawingArea
   drawingArea:setFontCompoundName("8.Helv")

   // default DBE group box
   oGroup1:=XbpStatic():new(drawingArea, , {12,120}, {120,132})
   oGroup1:caption:="Default DBE"
   oGroup1:clipSiblings:=.T.
   oGroup1:type:=XBPSTATIC_TYPE_GROUPBOX
   oGroup1:create()

   oDbe:=XbpCombobox():new(oGroup1, , {12,2}, {96,108}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD }, { XBP_PP_DISABLED_BGCLR, GRA_CLR_WHITE }})
   oDbe:tabstop:=.T.
   oDbe:type:=XBPCOMBO_DROPDOWN
   oDbe:XbpSLE:editable:=.F.
   oDbe:setInputFocus:={| uNil1,uNil2,self | XbpBorder(self,GRA_CLR_BLUE) }
   oDbe:killInputFocus:={| uNil1,uNil2,self | XbpBorder(self, GRA_CLR_BACKGROUND) }
   oDbe:create()
   oDbe:XbpSLE:setData(cDbe)
   aDbe:=DbeList()
   ASort(aDbe,,, {|aX,aY| aX[1] < aY[1] })

   For x:=1 To Len(aDbe)

      If aDbe[x,2]==.F.
         oDbe:addItem(aDbe[x,1])
      EndIf

   Next

   oDbe:ItemSelected:={|mp1, mp2, obj| SetFileType(obj:XbpSLE:getData(),oFileExt, oExtDesc) }

   // default file extension group box
   oGroup2:=XbpStatic():new(drawingArea, , {144,120}, {300,132})
   oGroup2:caption:="Default settings"
   oGroup2:clipSiblings:=.T.
   oGroup2:type:=XBPSTATIC_TYPE_GROUPBOX
   oGroup2:create()

   oXbp:=XbpStatic():new(oGroup2, , {12,84}, {108,24})
   oXbp:caption:="File Extension"
   oXbp:clipSiblings:=.T.
   oXbp:options:=XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_RIGHT
   oXbp:create()

   oFileExt:=XbpGet():new(oGroup2, , {156,84}, {48,24}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } })
   oFileExt:tabStop:=.T.
   oFileExt:picture:="@!"
   oFileExt:datalink:={|x| IIf(x==Nil,x:=cExtension,cExtension:=x) }
   oFileExt:bufferLength:=3
   oFileExt:setInputFocus:={| uNil1,uNil2,self | XbpBorder(self,GRA_CLR_BLUE) }
   oFileExt:killInputFocus:={| uNil1,uNil2,self | XbpBorder(self, GRA_CLR_BACKGROUND) }
   oFileExt:create()
   oFileExt:setData(cExtension)

   oXbp:=XbpStatic():new(oGroup2, , {12,48}, {108,24})
   oXbp:caption:="Description"
   oXbp:clipSiblings:=.T.
   oXbp:options:=XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_RIGHT
   oXbp:create()

   oExtDesc:=XbpSLE():new(oGroup2, , {156,48}, {132,24}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } })
   oExtDesc:tabStop:=.T.
   oExtDesc:datalink:={|x| IIf(x==Nil,x:=cExtDesc,cExtDesc:=x) }
   oExtDesc:setInputFocus:={| uNil1,uNil2,self | XbpBorder(self,GRA_CLR_BLUE) }
   oExtDesc:killInputFocus:={| uNil1,uNil2,self | XbpBorder(self, GRA_CLR_BACKGROUND) }
   oExtDesc:create()
   oExtDesc:setData(cExtDesc)

   oXbp:=XbpCheckbox():new(oGroup2, , {12,12}, {96,24})
   oXbp:caption:="Multi User"
   oXbp:tabStop:=.T.
   oXbp:selection:=lMultiUser
   oXbp:setInputFocus:={| uNil1,uNil2,self | XbpBorder(self,GRA_CLR_BLUE) }
   oXbp:killInputFocus:={| uNil1,uNil2,self | XbpBorder(self, GRA_CLR_BACKGROUND) }
   oXbp:create()
   oXbp:selected:={|| lMultiUser:=Iif(lMultiUser,.F.,.T.) }

   oXbp:=XbpCheckbox():new(oGroup2, , {156,12}, {96,24})
   oXbp:caption:="Show Deleted"
   oXbp:tabStop:=.T.
   oXbp:selection:=lShowDeleted
   oXbp:setInputFocus:={| uNil1,uNil2,self | XbpBorder(self,GRA_CLR_BLUE) }
   oXbp:killInputFocus:={| uNil1,uNil2,self | XbpBorder(self, GRA_CLR_BACKGROUND) }
   oXbp:create()
   oXbp:selected:={|| lShowDeleted:=Iif(lShowDeleted,.F.,.T.) }

   // default directory groupbox
   oGroup3:=XbpStatic():new(drawingArea, , {12,48}, {432,60})
   oGroup3:caption:="Default Data Directory"
   oGroup3:clipSiblings:=.T.
   oGroup3:type:=XBPSTATIC_TYPE_GROUPBOX
   oGroup3:create()

   oXbp:=XbpStatic():new(oGroup3, , {12,12}, {84,24})
   oXbp:caption:="Directory"
   oXbp:clipSiblings:=.T.
   oXbp:options:=XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_RIGHT
   oXbp:create()

   oDefDir:=XbpGet():new(oGroup3, , {108,12}, {292,24}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } })
   oDefDir:tabStop:=.T.
   oDefDir:datalink:={|x| IIf(x==Nil,x:=cDirectory,cDirectory:=x) }
   oDefDir:setInputFocus:={| uNil1,uNil2,self | XbpBorder(self,GRA_CLR_BLUE) }
   oDefDir:killInputFocus:={| uNil1,uNil2,self | XbpBorder(self, GRA_CLR_BACKGROUND) }
   oDefDir:create()
   oDefDir:setData(cDirectory)

   oXbp:=XbpPushButton():new(oGroup3, , {400,12}, {24,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } })
   oXbp:caption:="..."
   oXbp:tabStop:=.T.
   oXbp:create()
   oXbp:activate:={|| cDirectory:=SelectDirectory(cDirectory), oDefDir:setData(cDirectory) }

   oXbp:=XbpPushButton():new(drawingArea, , {240,12}, {96,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } })
   oXbp:caption:="Save"
   oXbp:tabStop:=.T.
   oXbp:create()
   oXbp:activate:={|| lSet:=.T., PostAppEvent(xbeP_Close+1000) }

   oXbp:=XbpPushButton():new(drawingArea, , {348,12}, {96,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } })
   oXbp:caption:=GEN_CLOSE
   oXbp:tabStop:=.T.
   oXbp:create()
   oXbp:activate:={|| lSet:=.F., PostAppEvent(xbeP_Close+1000) }

   oController:=XbpGetController():new(oDlg):create()
   oController:read(,.F.)

   oDlg:show()
   SetAppFocus(oDbe)
   nEvent:=xbe_None

   Do While nEvent<>xbeP_Close+1000
      nEvent:=AppEvent(@mp1, @mp2, @oXbp)
      oXbp:handleEvent(nEvent, mp1, mp2)
      if nEvent == xbeP_Keyboard .and.;
         mp1    == xbeK_ESC
         exit
      endif      
   EndDo

   If lSet
      aIniFile:=IniLoad(IniFileLoc())

      If oDbe:XbpSle:getData()<>cDbe   // changed DBE
         cDbe:=oDbe:XbpSle:getData()
         DbeSetDefault(cDbe)
         IniPut(aIniFile, "DEFAULTS", "DBE", cDbe)
         LoadDbeSettings()
      EndIf

      IniPut(aIniFile, "DEFAULTS", "TABLE_EXT", cExtension)
      IniPut(aIniFile, "DEFAULTS", "EXT_DESC", cExtDesc)

      If !Right(cDirectory,1)=="\"
         cDirectory+="\"
      EndIf

      IniPut(aIniFile, "DEFAULTS", "DATA_DIR", cDirectory)
      IniPut(aIniFile, "DEFAULTS", "SET_DELETED", Iif(lShowDeleted,"Off","On"))

      If lShowDeleted
         Set Deleted Off
      Else
         Set Deleted On
      EndIf

      IniPut(aIniFile, "DEFAULTS", "MULTI_USER", Iif(lMultiUser,"True","False"))
      IniSave(aIniFile, IniFileLoc())
      SetAppWindow():oInfoLine:SetCaption(IIf(lMultiUser,"MULTI-USER","NON MULTI-USER")+", SHOW DELETED "+IIf(lShowDeleted,"ON","OFF"))
   EndIf

   oDlg:destroy()
   SetAppFocus(oFocus)
End

Return Nil

****************
Func SetFileType(cDbe, oFileExt, oExtDesc)
****************
* set default extension options

Begin Sequence

   Do Case

      Case "DBF"$cDbe .Or. "FOX"$cDbe
         oFileExt:setData("DBF")
         oExtDesc:SetData("DBF Files")

      Case "SDF"$cDbe
         oFileExt:SetData("SDF")
         oExtDesc:SetData("SDF Files")

      Case "DEL"$cDbe
         oFileExt:SetData("CSV")
         oExtDesc:SetData("CSV Files")

   EndCase

End

Return  Nil
