* Program..: Password.prg
* Author...: Jeremy Suiter
* Date.....: 30/11/2004
*
* Notice...: Copyright (c) 2004, Jeremy Suiter, All Rights Reserved
* Notes....: Visual DbEditor printer setup functions

#Include "Gra.ch"
#Include "Xbp.ch"
#Include "Common.ch"
#Include "Appevent.ch"
#Include "Font.ch"
#Include "DbEditor.ch"
#Include "Resources.ch"

*****************************
CLASS Password FROM XbpDialog
*****************************
* password entry dialog
   EXPORTED:
      VAR editControls

      * Contained control elements
      VAR PushButton1
      VAR PushButton2
      VAR Static1
      VAR Static2
      VAR Combobox1
      VAR Static3
      VAR SLE1

      METHOD init
      METHOD create
ENDCLASS

********************
METHOD Password:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
********************
   DEFAULT aPP TO {}
   AAdd ( aPP, { XBP_PP_COMPOUNDNAME, "8.Helv" } )
   ::XbpDialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::XbpDialog:taskList := .T.
   ::XbpDialog:title := "User Entry"

   ::editControls := {}

   ::Static1     := XbpStatic():new( ::drawingArea, , {12,48}, {216,96} )
   ::Static1:caption := ""
   ::Static1:clipSiblings := .T.
   ::Static1:type := XBPSTATIC_TYPE_GROUPBOX

   ::Static2     := XbpStatic():new( ::Static1, , {12,48}, {60,24} )
   ::Static2:caption := "User Name"
   ::Static2:clipSiblings := .T.
   ::Static2:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_RIGHT

   ::Combobox1   := XbpCombobox():new( ::Static1, , {84,12}, {120,60}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   ::Combobox1:tabstop := .T.

   ::Static3     := XbpStatic():new( ::Static1, , {12,12}, {60,24} )
   ::Static3:caption := "Password"
   ::Static3:clipSiblings := .T.
   ::Static3:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_RIGHT

   ::SLE1        := XbpSLE():new( ::Static1, , {84,12}, {120,24}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   ::SLE1:tabStop := .T.
   ::SLE1:unReadable := .T.

   ::PushButton1 := XbpPushButton():new( ::drawingArea, , {96,12}, {60,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::PushButton1:caption := "Login"
   ::PushButton1:tabStop := .T.
   ::PushButton1:activate := {|| lClose:=CheckPassword(self) }

   ::PushButton2 := XbpPushButton():new( ::drawingArea, , {168,12}, {60,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::PushButton2:caption := "Quit"
   ::PushButton2:tabStop := .T.
   ::PushButton2:activate := {|| AppQuit(.T.) }

RETURN self

**********************
METHOD Password:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
**********************
   ::XbpDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
    ::PushButton1:create()
    ::PushButton2:create()
    ::Static1:create()
    ::Static2:create()
    ::Combobox1:create()
    ::Static3:create()
    ::SLE1:create()

   cUser:="MANAGER"
   ::Combobox1:XbpSLE:dataLink := {|x| IIf( x==NIL, cUser, cUser := x ) }
   ::Combobox1:XbpSLE:setData()
   ::Combobox1:addItem("MANAGER")
   ::Combobox1:addItem("USER")

RETURN self

******************
Func EnterPassword()
******************
* enter password dialog
Local nEvent, mp1:=Nil, mp2:=Nil, aPos, aSize, oFocus:=SetAppFocus(), oDlg, oXbp:=Nil
Private cUser, cPassword, lClose

Begin Sequence
   aSize:={254,190}
   aPos:=CenterPos(aSize,AppDesktop():currentSize())

   oDlg:=Password():new(AppDesktop(), SetAppWindow(), aPos, aSize, , .F.)
   oDlg:icon:=ICON_MAIN
   oDlg:taskList:=.F.
   oDlg:border:=XBPDLG_RAISEDBORDERTHIN_FIXED
   oDlg:close:={|mp1,mp2,obj| PostAppEvent(xbeP_Close+1000) }
   oDlg:create()
   oDlg:setModalState(XBP_DISP_APPMODAL)
   oDlg:keyBoard:={| nKeyCode, uNIL, self | Nil }

   oDlg:show()
   SetAppFocus(oDlg:SLE1)
   nEvent:=xbe_None
   lClose:=.F.

   Do While !lClose
      nEvent:=AppEvent(@mp1, @mp2, @oXbp)
      oXbp:handleEvent(nEvent, mp1, mp2)
      if nEvent == xbeP_Keyboard .and.;
         mp1    == xbeK_ESC
         lClose := .t.
      endif      
   EndDo

   If oDlg:Combobox1:XbpSLE:getData()=="USER"
      lEditable:=.F.
   EndIf

   oDlg:destroy()
   SetAppFocus(oFocus)
End

Return Nil

******************
Func CheckPassword(oDlg)
******************
* Check Password against user
Local lRetVal:=.F.

Begin Sequence
   cUser:=oDlg:Combobox1:XbpSLE:getData()
   cPassword:=oDlg:SLE1:getData()

   If cUser=="MANAGER"

      If cPassword==MANAGER
         lRetVal:=.T.
      EndIf

   ElseIf cUser=="USER"

      If cPassword==USER
         lRetVal:=.T.
      EndIf

   EndIf

   If !lRetVal
      Errm(ERR_ERRM35)
      oDlg:SLE1:setData("")
      SetAppFocus(oDlg:SLE1)
   EndIf

End

Return lRetVal
