* Program..: Structure.prg
* Author...: Jeremy Suiter
* Date.....: 19/03/2003
*
* Notice...: Copyright (c) 2003, Jeremy Suiter, All Rights Reserved
* Notes....: Visual DbEditor database structure create/edit functions

#INCLUDE "common.CH"
#Include "Gra.ch"
#Include "Xbp.ch"
#Include "Appevent.ch"
#Include "DbEditor.ch"
#Include "Dll.ch"
#Include "Font.ch"
#Include "FoxDbe.ch"
#Include "CdxDbe.ch"
#Include "Dmlb.ch"
#Include "Dbstruct.ch"
#Include "Resources.ch"

// structure of the array
#Define  ARR_SRC   1              // array (Data source)
#Define  ARR_NO    2              // 'record pointer' for array
#Define  ARR_COUNT 2

Static oStruBrowse:=Nil, aStructure:={}, aOrigStru:={}, oAppend:=Nil, oText := NIL

**************
Func Structure(lNew)
**************
Local nEvent:=Nil, mp1:=Nil, mp2:=Nil, aPos:={}, aPP:={}, oColumn:=Nil, oFocus:=SetAppFocus()
Local oStruDlg, oXbp, drawingArea, oGroup1

Begin Sequence

   If !lNew .And. oFocusBrowse==Nil
      Break
   EndIf

   aStructure:=StruArray(lNew)
   aOrigStru:=DbStruct()

   aPos:=CenterPos({369,456},AppDesktop():currentSize())

   oStruDlg:=XbpDialog():new(AppDesktop(), SetAppWindow(), aPos, {369,456}, , .F.)
   oStruDlg:icon:=ICON_MAIN
   oStruDlg:taskList:=.T.
   oStruDlg:border:=XBPDLG_RAISEDBORDERTHIN_FIXED
   oStruDlg:title:=IIf(lNew,"Create New Table","Modify Table Structure")
   oStruDlg:close:={|mp1,mp2,obj| PostAppEvent(xbeP_Close+1000) }
   oStruDlg:create()
   oStruDlg:setModalState(XBP_DISP_APPMODAL)
   oStruDlg:keyBoard:={| nKeyCode, uNIL, self | Iif(nKeyCode==xbeK_ESC,PostAppEvent(xbeP_Close+1000),Nil) }

   drawingArea:=oStruDlg:drawingArea
   drawingArea:setFontCompoundName("8.Helv")

   // browse of structure details
   oGroup1:=XbpStatic():new(drawingArea, , {12,48}, {336,372})
   oGroup1:caption:="Structure Details"
   oGroup1:clipSiblings:=.T.
   oGroup1:type:=XBPSTATIC_TYPE_GROUPBOX
   oGroup1:create()

   // Create browser in the window
   oStruBrowse:=XbpBrowse():new(oGroup1, , {12,87}, {312,270}, PRESPARAM_FANCY,.F.):create()
   oStruBrowse:hScroll:=.F.
   oStruBrowse:sizeCols:=.F.
   // 04/18/03 by MMM
   oStruBrowse:softTrack    := .F.

   StruSkipBlock()

   // field name
   aPP:={{XBP_PP_COL_HA_CAPTION, "FIELD NAME     " }, ;
         {XBP_PP_COL_FA_CAPTION, "FIELD NAME     " }, ;
         {XBP_PP_COL_HA_BGCLR, GRA_CLR_DARKGRAY }, ;
         {XBP_PP_COL_HA_FGCLR, GRA_CLR_WHITE }, ;
         {XBP_PP_COL_FA_BGCLR, GRA_CLR_DARKGRAY }, ;
         {XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE }}
   oColumn             :=XbpGetColumn():new(oStruBrowse,,,, aPP)
   oColumn:dataLink    :=ArrayBlock(aStructure,1)
   oColumn:bufferLength:=10
   oColumn:picture:="@!"
   oStruBrowse:addColumn(oColumn)

    // field type
   aPP:={{XBP_PP_COL_HA_CAPTION, "FIELD TYPE" }, ;
         {XBP_PP_COL_FA_CAPTION, "FIELD TYPE" }, ;
         {XBP_PP_COL_HA_BGCLR, GRA_CLR_DARKGRAY }, ;
         {XBP_PP_COL_HA_FGCLR, GRA_CLR_WHITE }, ;
         {XBP_PP_COL_FA_BGCLR, GRA_CLR_DARKGRAY }, ;
         {XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE }}
   oColumn             :=XbpGetColumn():new(oStruBrowse,,,, aPP)
   oColumn:dataLink    :=ArrayBlock(aStructure,2)
   oColumn:bufferLength:=1
   oColumn:picture:="@!"
   oStruBrowse:addColumn(oColumn)

   // field length
   aPP:={{XBP_PP_COL_HA_CAPTION, "LENGTH" }, ;
         {XBP_PP_COL_FA_CAPTION, "LENGTH" }, ;
         {XBP_PP_COL_HA_BGCLR, GRA_CLR_DARKGRAY }, ;
         {XBP_PP_COL_HA_FGCLR, GRA_CLR_WHITE }, ;
         {XBP_PP_COL_FA_BGCLR, GRA_CLR_DARKGRAY }, ;
         {XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE }}
   oColumn             :=XbpGetColumn():new(oStruBrowse,,,, aPP)
   oColumn:dataLink    :=ArrayBlock(aStructure,3)
   oColumn:bufferLength:=2
   oColumn:picture     :="999"
   oStruBrowse:addColumn(oColumn)

   // field decimal
   aPP:={{XBP_PP_COL_HA_CAPTION, "DECIMAL" }, ;
         {XBP_PP_COL_FA_CAPTION, "DECIMAL" }, ;
         {XBP_PP_COL_HA_BGCLR, GRA_CLR_DARKGRAY }, ;
         {XBP_PP_COL_HA_FGCLR, GRA_CLR_WHITE }, ;
         {XBP_PP_COL_FA_BGCLR, GRA_CLR_DARKGRAY }, ;
         {XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE }}
   oColumn             :=XbpGetColumn():new(oStruBrowse,,,, aPP)
   oColumn:dataLink    :=ArrayBlock(aStructure,4)
   oColumn:bufferLength:=2
   oColumn:picture     :="99"
   oStruBrowse:addColumn(oColumn)

   // recessed static for index progress bar
   oText:=XbpStatic():new(oGroup1, , {12,60}, {312,20})
   oText:type:=XBPSTATIC_TYPE_TEXT
   oText:create()

   oAppend:=ProgressBar():new(oGroup1, , {12,42}, {312,15},,.F.)
   oAppend:create()
   oAppend:hide()

   // structure change pushbuttons
   oXbp:=XbpPushButton():new(oGroup1, , {12,12}, {55,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } })
   oXbp:caption:="Insert"
   oXbp:tabStop:=.T.
   oXbp:create()
   oXbp:activate:={|| AddStruItem(.T.) }

   oXbp:=XbpPushButton():new(oGroup1, , {75,12}, {75,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } })
   oXbp:caption:="Insert before"
   oXbp:tabStop:=.T.
   oXbp:create()
   oXbp:activate:={|| AddStruItem() }

   oXbp:=XbpPushButton():new(oGroup1, , {161,12}, {55,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } })
   oXbp:caption:=GEN_DELETE
   oXbp:tabStop:=.T.
   oXbp:create()
   oXbp:activate:={|| DelStruItem() }

   oXbp:=XbpPushButton():new(oGroup1, , {228,12}, {96,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } })
   oXbp:caption:="Save changes"
   oXbp:tabStop:=.T.
   oXbp:create()
   oXbp:activate:={|| IIf(lNew,CreateTable(),ModifyTable()) }

   // Structure into clipboard pushbutton
   oXbp:=XbpPushButton():new(drawingArea, , {141,12}, {96,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } })
   oXbp:caption:="Stru to clipboard"
   oXbp:tabStop:=.T.
   oXbp:create()
   oXbp:activate:={|| StruToClipboard() }

   // close pushbutton
   oXbp:=XbpPushButton():new(drawingArea, , {252,12}, {96,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } })
   oXbp:caption:=GEN_CLOSE
   oXbp:tabStop:=.T.
   oXbp:create()
   oXbp:activate:={|| PostAppEvent(xbeP_Close+1000,,,oStruDlg) }

   oStruDlg:show()
   // Delegate keys for editing to the Xbp???Column object
   oStruBrowse:keyBoard:={ |nKey, x, obj| StruBrowseKeys(nKey, obj) }
   oStruBrowse:show()
   SetAppFocus(oStruBrowse)
   nEvent:=xbe_None

   Do While nEvent<>xbeP_Close+1000
      nEvent:=AppEvent(@mp1, @mp2, @oXbp)
      oXbp:handleEvent(nEvent, mp1, mp2)
      if nEvent == xbeP_Keyboard .and.;
         mp1    == xbeK_ESC
         exit
      endif
   EndDo

   oStruDlg:destroy()

   If !oFocusBrowse==Nil
      SetAppFocus(oFocusBrowse)
   Else
      SetAppFocus(oFocus)
   EndIf

End

Return Nil

*******************
Func StruBrowseKeys(nKey, obj)
*******************
* handle browse keys

Begin Sequence

   Do Case

      Case nKey>31 .Or. nKey<256  // normal keys for editing
         obj:getColumn(obj:colPos):keyboard(nKey)

   EndCase

End

Return Nil

******************
Func StruSkipBlock()
******************

Begin Sequence
   oStruBrowse:cargo        :=aStructure
   oStruBrowse:skipBlock    :={|n,obj| SkipArray(n, obj:cargo) }
   oStruBrowse:goTopBlock   :={|obj| obj:cargo[ ARR_NO ]:=1 }
   oStruBrowse:goBottomBlock:={|obj| obj:cargo[ ARR_NO ]:=Len(obj:cargo[ ARR_SRC ]) }
   oStruBrowse:posBlock     :={|obj| obj:cargo[ ARR_NO ] }
   oStruBrowse:phyPosBlock  :={|obj| obj:cargo[ ARR_NO ] }
   oStruBrowse:lastPosBlock :={|obj| Len(obj:cargo[ ARR_SRC ]) }
   oStruBrowse:firstPosBlock:={|obj| 1  }
End

Return Nil

**************
Func StruArray(lNew)
**************
* Create an array which contains all data necessary to browse a 2-dim array
* - ARR_SRC : Data source
* - ARR_NO  : 'record pointer'
Local aArray[ARR_COUNT], aTemp:={}

Begin Sequence
   // blank array If required
   aTemp:={{PADR("<NEW>",10), " ", 0, 0}}

   // create browse array
   aArray[ARR_SRC]:=Iif(lNew,aTemp,DbStruct())
   Aeval(aArray[ARR_SRC], {|x,y| aArray[ARR_SRC,y,1]:=Padr(aArray[ARR_SRC,y,1],10) })
   aArray[ARR_NO ]:=1
End

Return aArray

***************
Func ArrayBlock(aArray, nSubScript)
***************
Return {|x| IIf(x=Nil, IIf(ValType(x)=="C",Padr(aArray[ARR_SRC, aArray[ARR_NO], nSubScript],10),aArray[ARR_SRC, aArray[ARR_NO], nSubScript]), ;
   aArray[ARR_SRC, aArray[ARR_NO], nSubScript]:=x) }

**************
Func SkipArray(nWantSkip, aArray)
**************
Local nDidSkip, nLastRec:=Len(aArray[ARR_SRC])

Begin Sequence

   If aArray[ARR_NO]+nWantSkip < 1              // "Bof"
      nDidSkip:=1-aArray[ARR_NO]
   ElseIf aArray[ ARR_NO ]+nWantSkip>nLastRec   // "Eof"
      nDidSkip:=nLastRec-aArray[ARR_NO]
   Else
      nDidSkip:=nWantSkip
   EndIf

   aArray[ARR_NO]+=nDidSkip
End

Return nDidSkip

****************
Func AddStruItem( lInsertBehind )
****************
* add item to structure array
Local aTemp:=aStructure[ARR_SRC]

DEFAULT lInsertBehind TO .F.

Begin Sequence

   If !(Len(aTemp)==1 .And. aTemp[1,1]==PADR("<NEW>", 10)) .And. Len(aTemp)<=254
      Aadd(aTemp,Nil)
      AIns(aTemp,aStructure[ARR_NO] + IIF( lInsertBehind, 1, 0),{PADR("<NEW>",10), "C", 1, 0})
      // aStructure[ARR_NO] := aStructure[ARR_NO]+ IIF( lInsertBehind, 1, 0)
      aStructure[ARR_SRC]:=aTemp
      StruSkipBlock()
      oStruBrowse:refreshAll()
      IF lInsertBehind
         oStruBrowse:Down()
      ENDIF
      oStruBrowse:forceStable()

   EndIf

End

Return Nil

****************
Func DelStruItem()
****************
* delete item from structure array
Local aTemp:=aStructure[ARR_SRC], x

Begin Sequence

   // check to see If it's a field in the index
   For x:=1 To OrdCount()

      If aStructure[ARR_SRC,aStructure[ARR_NO],1]$OrdKey(x)
         Errm(ERR_ERRM41)
         Break
      EndIf

   Next

   // remove field If ok
   If Len(aTemp)>=2
      ARemove(aTemp,aStructure[ARR_NO])
      aStructure[ARR_SRC]:=aTemp
      StruSkipBlock()
      oStruBrowse:refreshAll()
      oStruBrowse:forceStable()
   EndIf

End

Return Nil

****************
Func CreateTable()
****************
* create new table
Local aStru:=aStructure[ARR_SRC]
Local oDlg:=Nil, cFile:="", oFocus:=SetAppFocus()
Local lRetVal:=.T.

Begin Sequence

   If !StructureOK() .And. !YesNo("Create new table","Create")
      lRetVal:=.F.
      Break
   EndIf

   // get filename
   oDlg:=XbpFileDialog():new()
   oDlg:fileFilters:={ {cExtDesc,cExtension} }
   oDlg:center:=.T.
   oDlg:create()

   Do While .T.
      cFile:=oDlg:saveAs(cDirectory+"*."+cExtension)

      If File(cFile) .And. !YesNo("File already exists, overwrite","Overwrite")
         Loop
      Else
         Exit
      EndIf

   EndDo

   oDlg:destroy()
   SetAppFocus(oFocus)

   If Empty(cFile)
      lRetVal:=.F.
      Break
   EndIf

   DbCreate(cFile, aStru)

   If !File(cFile)
      Errm(ERR_ERRM42)
      lRetVal:=.T.
   Else
      Errm(ERR_ERRM43,ERR_ERRM44)
   EndIf

End

Return lRetVal

****************
Func ModifyTable()
****************
Local aStru:=aStructure[ARR_SRC], cTempFile:=Left(cFile,At(".",cFile)-1)+"~."+cExtension, bBlock, lShared:=DbInfo(DBO_SHARED), cFileDbe:=DbInfo(DBO_DBENAME)
Local oError, bSaveErrorBlock:=ErrorBlock({|oError| Break(oError)}), lRetVal:=.T.
LOCAL oDlg

Begin Sequence

   If !StructureOK() .And. !YesNo("Modify structure","Modify")
      Break
   EndIf

   DbCreate(cTempFile, aStru, cFileDbe)

   If !File(cTempFile)
      Errm(ERR_ERRM45)
      Break
   EndIf

   oAppend:minimum:=1
   oAppend:maximum:=LastRec()
   oAppend:current:=1
   DbCloseArea()

   If !NetUse(cTempFile,,,,cFileDbe)
      Break
   EndIf

   oText:SetCaption("Changing Structure")

   oAppend:show()
   bBlock:={|| oAppend:increment(), .T. }
   DbImport(cFile,,bBlock)
   oAppend:hide()
   DbCloseArea()

   If FErase(cFile)==-1
      Errm(ERR_ERRM46)
      lRetVal:=.F.
      Break
   EndIf

   If File(Left(cFile,Len(cFile)-3)+"FPT") .And. FErase(Left(cFile,Len(cFile)-3)+"FPT")==-1
      Errm(ERR_ERRM47)
      lRetVal:=.F.
      Break
   EndIf

   If File(Left(cFile,Len(cFile)-3)+"DBT") .And. FErase(Left(cFile,Len(cFile)-3)+"DBT")==-1
      Errm(ERR_ERRM48)
      lRetVal:=.F.
      Break
   EndIf

   If Frename(cTempFile,cFile)==-1
      Errm(ERR_ERRM49)
      lRetVal:=.F.
      Break
   Else

      If File(Left(cTempFile,Len(cTempFile)-3)+"FPT") .And. Frename(Left(cTempFile,Len(cTempFile)-3)+"FPT",Left(cFile,Len(cFile)-3)+"FPT")==-1
         Errm(ERR_ERRM50)
         lRetVal:=.F.
         Break
      EndIf

      If File(Left(cTempFile,Len(cTempFile)-3)+"DBT") .And. Frename(Left(cTempFile,Len(cTempFile)-3)+"DBT",Left(cFile,Len(cFile)-3)+"DBT")==-1
         Errm(ERR_ERRM50)
         lRetVal:=.F.
         Break
      EndIf

   EndIf

Recover Using oError

   Errm(ERR_ERRM51)
   lRetVal:=.F.

End

// re-open original file (with new structure hopefully)
   If !NetUse(cFile,!lShared,,,cFileDbe)
   lRetVal:=.F.
      Break
   EndIf

   oText:SetCaption("Rebuilding browser, please wait...")

   oFocusBrowse:Hide()

   /*
      Get parent dialog of browser, destroy the browser and
      re-build it the same way like it is created the first time
      in utilities.prg.

      This is many times faster than the previous method of removing
      and adding all the columns again. (tb)
   */
   oDlg := oFocusBrowse:SetParent():SetParent()
   oFocusBrowse:Destroy()

   oAppend:minimum := 1
   oAppend:maximum := fcount()
   oAppend:current := 1

oAppend:show()
EditBrowse(oDlg) //, oAppend) // temporarily removed as the progress bar stops the new browse window from displaying properly
oAppend:hide()

oFocusBrowse:Show()
   oFocusBrowse:forceStable()
   oText:SetCaption("")

// Restore prior error block
ErrorBlock(bSaveErrorBlock)
Return lRetVal

****************
Func StructureOK()
****************
Local lOk:=.T.,x ,y, aStru:=aStructure[ARR_SRC]

Begin Sequence

   // check to see if it's the same structure
   If Len(aStru)==Len(aOrigStru)

      For x:=1 To Len(aStru)

         If !aStru[x,1]==aOrigStru[x,1] .Or. !aStru[x,2]==aOrigStru[x,2] .Or. !aStru[x,3]==aOrigStru[x,3] .Or. !aStru[x,4]==aOrigStru[x,4]
            lOk:=.F.
            Exit
         EndIf

      Next

      If lOk
         Errm(ERR_ERRM52)
         lOk:=.F.
         Break
      EndIf

   EndIf

   lOk:=.T.

   // check for correct structure
   For x:=1 To Len(aStru)

      If Empty(aStru[x,2])
         Errm(ERR_ERRM53)
         lOk:=.F.
         Exit
      EndIf

      If aStru[x,3]<0
         Errm(ERR_ERRM54)
         lOk:=.F.
         Exit
      EndIf

      If aStru[x,4]<0
         Errm(ERR_ERRM55)
         lOk:=.F.
         Exit
      EndIf

      // check field dec and length ok for field types
      If aStru[x,2]=="C"

         If aStru[x,3]>255
            Errm(ERR_ERRM56)
            lOk:=.F.
            Exit
         ElseIf aStru[x,4]>0
            Errm(ERR_ERRM57)
            lOk:=.F.
            Exit
         EndIf

      ElseIf aStru[x,2]=="N"

         If aStru[x,3]+aStru[x,4]>19
            Errm(ERR_ERRM58)
            lOk:=.F.
            Exit
         EndIf

      ElseIf aStru[x,2]=="D"

         If aStru[x,3]>8
            Errm(ERR_ERRM56)
            lOk:=.F.
            Exit
         ElseIf aStru[x,4]>0
            Errm(ERR_ERRM57)
            lOk:=.F.
            Exit
         EndIf

      ElseIf aStru[x,2]=="L"

         If aStru[x,3]>1
            Errm(ERR_ERRM56)
            lOk:=.F.
            Exit
         ElseIf aStru[x,4]>0
            Errm(ERR_ERRM57)
            lOk:=.F.
            Exit
         EndIf

      EndIf

      // illegal character in field name
      For y:=1 To Len(aStru[x,1])
         aStru[x,1]:=AllTrim(aStru[x,1])  // strip off spaces

         If !(Asc(SubStr(aStru[x,1],y,1))>=65 .And. Asc(SubStr(aStru[x,1],y,1))<=90) .And. ;
               !(Asc(SubStr(aStru[x,1],y,1))>=48 .And. Asc(SubStr(aStru[x,1],y,1))<=57) .And. !Asc(SubStr(aStru[x,1],y,1))==95
            Errm(ERR_ERRM59)
            lOk:=.F.
            Exit
         EndIf

      Next

      If !lOk
         Exit
      EndIf

   Next

End

Return lOk

********************
Func StruToClipboard()
********************
LOCAL oClip := XbpClipBoard():new():create()
LOCAL cBuf := "{"
LOCAL nMax

   IF oClip:Open()
      oClip:Clear()
      nMax := LEN(aStructure[ARR_SRC])
      AEVAL( aStructure[ARR_SRC], {|aE, i| cBuf += '{"' + TRIM(aE[1]) + '", "' + aE[2] + '",' + LTRIM(STR(aE[3])) + "," + LTRIM(STR(aE[4])) + "}"+ IIF( i!=nMax, ",;" + CRLF, "}") } )
      IF oClip:SetBuffer(cBuf)
         Errm("Structure written to clipboard.")
      ELSE
         Errm("Could not write data to clipboard.")
      ENDIF
      oClip:Close()
   ELSE
      Errm("Clipboard could not be opened.")
   ENDIF

RETURN NIL
